/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2008, 2011 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
//function HxG_6 () {
//}

HxG_6.prototype.HxSearch=function(
	searchCompId,
	clearImgId, 
	searchImgId, 
	searchInputId, 
	defaultSearchTxt, 
	clearImgSrc, 
	parent, userDefault,isRTL) {
	
	this.searchCompId = searchCompId;
	this.parent = parent;
	this.isIE = (this.parent.navigator.appName == "Microsoft Internet Explorer");

	this.defaultSearchTxt = defaultSearchTxt;

	this.clearImgId = clearImgId;
	this.searchImgId = searchImgId;
	this.searchInputId = searchInputId;

	this.clearImgObj = document.getElementById(clearImgId);
	this.clearImgObjSrcObj = document.getElementById(clearImgId + "SRC");
	this.searchImgObj = document.getElementById(searchImgId);
	this.searchInputObj = document.getElementById(searchInputId);
	this.userDefault = userDefault;
	var RTL = false;
	this.RTL = isRTL;
	
  	if(!this.clearImgObj || !this.clearImgObjSrcObj) {
		alert("RUNTIME ERROR: clearImg not found: "+clearImgId);
		return;
	}
	
	this.clearImgSrc  = clearImgSrc;
	this.clearImgSrcI = this.clearImgObjSrcObj.src;

	if(!this.searchImgObj) {
		alert("RUNTIME ERROR: searchImg not found: "+searchImgId);
		return;
	}

  	if(!this.searchInputObj) {
		alert("RUNTIME ERROR: searchInput not found: "+searchInputId);
		return;
	}
}

HxG_6.prototype.HxSearch.prototype.onPageLoad=function () {
//	printlnTable("\n onPageLoad");
	//post an event that will be called after the page is loaded so the 
	//clear image can be rendered correctly (otherwise offsets dimesions are not correct).
	var commandToRun = "hX_6.getComponentById('" + this.searchCompId + "').redraw();";
	
	//redraw now and register for onload
	this.redraw();
	hX_6.attachEvent(document.body, "onload", "l", commandToRun);
	
	
	
	this.resetSearchInput();
}

HxG_6.prototype.HxSearch.prototype.onMouseOver=function () {
	this.clearImgObjSrcObj.src = this.clearImgSrc;
}

HxG_6.prototype.HxSearch.prototype.onMouseOut=function () {
	this.clearImgObjSrcObj.src = this.clearImgSrcI;
}

HxG_6.prototype.HxSearch.prototype.onFocus=function () {
//	printlnTable("\n onFocus");
	if (this.isSearchInputClear()) {
			this.searchInputObj.value = '';
			this.resetCaretPosition();
	} else {
		this.redraw();
	}
}

HxG_6.prototype.HxSearch.prototype.resetCaretPosition=function() {

	//reset caret position in IE so it shows
	if (hX_6.brw.isIE())
    {
       	// Create empty selection range
       	var oSel = document.selection.createRange();
  
       	// Move selection to 0 position
      	oSel.moveStart('character', 0);
  
        // Move selection to desired position
       	oSel.moveStart('character', 0);
        oSel.moveEnd('character', 0);
        oSel.select();	 
    }
}

HxG_6.prototype.HxSearch.prototype.isSearchInputClear=function () {
	
	var inputText = this.searchInputObj.value;
	var length = inputText.length;
	//printlnTable("\nlength: "+length+" value: "+inputText);	
	if (length == 0) {
		printlnTable("\n length is zero");
	} else {
		//printlnTable("\n length is: "+length);	
	}
	if (!this.userDefault && inputText.match(this.defaultSearchTxt)) {
		printlnTable("match found!: "+this.defaultSearchTxt);
	} else {
		printlnTable("\n not a match!");
	}
	//printlnTable('\n match: '+inputText.match(this.defaultSearchTxt));
	if (length == 0 || (!this.userDefault && inputText.match(this.defaultSearchTxt))) {
		printlnTable('\nisClear');
		return true;
	} else {
		//printlnTable('\nisNotClear');
		return false;
	}
}



HxG_6.prototype.HxSearch.prototype.redraw=function () {
	if (this.isSearchInputClear()) {
		//printlnTable("\nredraw.hideImages");
		this.setEmptySearchInputImages();
	} else {
		//printlnTable("\nredraw.showImages");
		this.setSearchInputImages();
	}
}

HxG_6.prototype.HxSearch.prototype.onBlur=function () {
//	printlnTable("\n onBlur");
	this.redraw();
	this.resetSearchInput();
}

HxG_6.prototype.HxSearch.prototype.resetSearchInput=function () {
	if (this.isSearchInputClear()) {
		this.setSearchInputToDefault();
	}
}

HxG_6.prototype.HxSearch.prototype.setSearchInputToDefault=function () {
	this.searchInputObj.value = this.defaultSearchTxt;
	if (this.userDefault) {
		this.setSearchInputImages();
	}
}

HxG_6.prototype.HxSearch.prototype.onKeyup=function () {
	this.redraw();
}

HxG_6.prototype.HxSearch.prototype.setEmptySearchInputImages=function () {
	this.clearImgObj.style.display = "none";
	this.searchImgObj.disabled = true;
}

HxG_6.prototype.HxSearch.prototype.setSearchInputImages=function () {	

	if (this.isIE) {
		this.clearImgObj.style.display = "";
	}

	//display the image so we have offset height and width
	this.clearImgObj.style.display = "inline";
	
	//J var clearImageHeight = this.clearImgObj.offsetHeight;
	var clearImageWidth = this.clearImgObj.offsetWidth;	
	
	if(this.RTL){
		this.clearImgObj.style.right = (this.searchInputObj.offsetWidth - clearImageWidth) + 'px';
	}else{
		this.clearImgObj.style.left = (this.searchInputObj.offsetWidth - clearImageWidth) + 'px';
	}
	
	this.searchImgObj.disabled = false;
}

HxG_6.prototype.HxSearch.prototype.clearQuickSearch=function () {

	var result = true;
	//printlnTable("\nclearQuickSearch value: "+this.searchInputObj.value+" defaultValue: "+this.searchInputObj.defaultValue);	
	if(this.searchInputObj.value.match(this.searchInputObj.defaultValue)) {
		result = false;
	}
	if (result) {
		printlnTable("\nclearQuickSearch server");	
	} else {
		printlnTable("\nclearQuickSearch client");	
	}

	this.setEmptySearchInputImages();
	this.setSearchInputToDefault();	
	return result;
}

HxG_6.prototype.HxSearch.prototype.onSearch=function () {
	if (!this.isSearchInputClear()) {
		alert('searching table...');
	}
	return false;
}

function printlnTable(s) {

	if (hX_6.brw.isIE()) {
	} else if (hX_6.brw.isFirefox()) {
		dump(s);
		return;
	}

	var console = document.getElementById("console")
	if (console != null) {
		var div = document.createElement("div");
		div.appendChild( document.createTextNode(s));
		console.appendChild(div);
	}
}
