/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2008, 2011 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
////////////////////////////////////////////////////////////////////////
//IBM Confidential
//
//OCO Source Materials
//
//The Source code for this program is not published or otherwise
//divested of its trade secrets, irrespective of what has been
//deposited with the U.S. Copyright Office
//
//(C) Copyright IBM Corp. 2007
//**********************************************************************
////////////////////////////////////////////////////////////////////////
//CHANGE ACTIVITY:
//
//Flag Reason    Release   Date       Userid      Comments
// auiml3911     v7r0      06/28/2007 andya       Created for new tree
// auiml3977     v7r0      08/28/2007 andya       Treetable rewrite based on EDT
//
////////////////////////////////////////////////////////////////////////
//
// Note: This file will eventually be contributed back to usmi/jwl
// Don't put any AUIML specific code in here
//


treeTable_treeToggle = function(tableid, nodeid)
{
    var table = document.getElementById(tableid);
	var node = document.getElementById(nodeid);
    var input = node_getInput(node);
    var type = input.value.split('	')[1];
    if(type == 'folder-open'){
        treeTable_collapseTreeNode(table,node);
    }
    else if(type == 'folder-closed'){
        treeTable_expandTreeNode(table,node);
    }
}

treeTable_keyPressToggle = function(e, tableid, nodeid)
{
	var keynum;
    var keychar;
    var numcheck;
    if(window.event) {
        keynum = e.keyCode;
    }
    else if(e.which){
        keynum = e.which;
    }
    keychar = String.fromCharCode(keynum);
    if(keychar == ' ') {
	    treeTable_treeToggle(tableid, nodeid);
    }
}

treeTable_keyPressSelect = function(e, tableid, nodeid)
{
    var table = document.getElementById(tableid);
    var node = document.getElementById(nodeid);
	var keynum;
    var keychar;
    var numcheck;
    if(window.event) {
        keynum = e.keyCode;
    }
    else if(e.which){
        keynum = e.which;
    }
    keychar = String.fromCharCode(keynum);
    table.clickType = 'click';
    if(keychar == ' ') {
	    treeTable_markNode(table, node);
    }
}

treeTable_addSelectedNode = function(table, nodeid)
{
	table.selectedNode[table.selectedNode.length] = nodeid;
}

treeTable_removeSelectedNode = function(table, nodeid)
{
    var newArray = new Array();
    for(var i = 0; i < table.selectedNode.length; i++){
        var selId = table.selectedNode[i];
        if (selId != nodeid)
        {
        	newArray[newArray.length] = selId;
        }
    }
    table.selectedNode = newArray;
}

treeTable_unmarkNode = function(table, node)
{
	treeTable_setLinkStyle(table, node, false);
	treeTable_removeSelectedNode(table, node.id);
	
	node_removeSelectedText(table, node);
	
    var input = node_getInput(node);
	var vals = input.value.split('\t');
	vals[3] = 'false';
	input.value = vals[0] + '\t' + vals[1] + '\t' + vals[2] + '\t' + vals[3] + '\t' + vals[4];
}

treeTable_setLinkStyle = function(table, node, selected)
{
    var children = node.childNodes;
    if (children.length == 1 && children[0].nodeName == 'TABLE') { // tree items with context menus
    	children = children[0].childNodes; // tbody
    	children = children[0].childNodes; // tr
    	children = children[0].childNodes; // td
    	children = children[0].childNodes; // element
    }
    var action = node.getAttribute('daction');
    for(var i = 0; i < children.length; i++){
        var child = children[i];
        if(child.nodeName == 'BUTTON' && child.childNodes.length > 0){
        	var span = child.childNodes[0];
	        if(span.nodeName == 'SPAN' && (span.className == 'node-label') || (span.className == 'node-label-sel') || (span.className == 'node-label-action') || (span.className == 'node-label-sel-action')){
	            if(selected){
	            	if (action) {
	            		span.className = 'node-label-sel-action';
	            	} else {
	                	span.className = 'node-label-sel';
	            	}
	            }
	            else {
	            	if (action) {
	            		span.className = 'node-label-action';
	            	} else {
	            		span.className = 'node-label';
	            	}
	            }
	        }
        } else if (child.nodeName == 'A' && child.className == 'check-box') {
        	var imgs = child.getElementsByTagName('IMG');
        	if (selected) {
        		imgs[0].src = table.checkedIcon;
        	} else {
        		imgs[0].src = table.uncheckedIcon;
        	}       	
        }
    }
}

treeTable_submitPage = function(tableid) {
	var table = document.getElementById(tableid);
    var submitFunc = table.submitFunc;
    if (!submitFunc || submitFunc == 'null')
    {
    	var form = treeTable_findFormByElement(table);
    	return form.submit();
    }
    eval(submitFunc + "('" + tableid + "')");
}

treeTable_clickNode = function(e, tableid, nodeid)
{
    var table = document.getElementById(tableid);
    var node = document.getElementById(nodeid);
    table.ctrlClick = e.ctrlKey;
    table.clickType = 'click';
	treeTable_markNode(table, node);
}

treeTable_keyPressCheckNode = function(e, tableid, nodeid)
{
	var table = document.getElementById(tableid);
	var node = document.getElementById(nodeid);
	var keynum;
    var keychar;
    var numcheck;
    if(window.event) {
        keynum = e.keyCode;
    }
    else if(e.which){
        keynum = e.which;
    }
    keychar = String.fromCharCode(keynum);
    if(keychar == ' ') {
	    treeTable_checkNode(table, node);
    }
}

treeTable_checkNode = function(table, node)
{
    table.ctrlClick = true;
    table.clickType = 'checkBoxClick';
	treeTable_markNode(table, node);
}

treeTable_markNode = function(table, node, skipFocus)
{
    var action = node.getAttribute('daction');
    if (!node_isSelectable(node) && !action) {
		return;
	}
	if(skipFocus){
    	treeTable_highlightNode(table, node, skipFocus);
   	}
   	else {
    	treeTable_highlightNode(table, node);
   	}
    if (action && (action == 'true') && (table.clickType != 'checkBoxClick')) {
    	treeTable_submitPage(tableid);
    	return;
    }
	if (table.notifySelect == 'true') {
	    var ajax = node.getAttribute('ajaxsel');
	    if (ajax) {
	    	if (ajax == 'true') {
	    	    return hX_6.getBehaviorById(tableid, 'ajaxsubmit', 'onget').dispatchBehavior(null, null);
	    	}
	    }
		treeTable_submitPage(tableid);
	}
}

treeTable_isNodeSelected = function(table, nodeid)
{
    for(var i = 0; i < table.selectedNode.length; i++){
    	var selNodeId = table.selectedNode[i];
    	if (nodeid == selNodeId)
    	{
    		return true;
    	}
    }
    return false;
}

treeTable_unmarkAll = function(table)
{
	 while (table.selectedNode.length > 0){
	 	 var selNodeId = table.selectedNode[0];
	 	 var node = document.getElementById(selNodeId);
	 	 treeTable_unmarkNode(table, node);
	 }
	 table.selectedNode = new Array();
}

treeTable_highlightNode = function(table, node, skipFocus)
{
    if (table.ctrlClick && !skipFocus) {
    	try {
    		node.focus();
    	} catch (e) {
    		// TODO: handle exception
    	}
    }
	if (table.multiSelect == 'true')
	{
		if (!table.ctrlClick)
		{
			treeTable_unmarkAll(table);
		} else {
			if (treeTable_isNodeSelected(table, node.id)) {
				treeTable_unmarkNode(table, node);
				return;
			}
		}
	} else {
		treeTable_unmarkAll(table);
	}
	var inputs = node.getElementsByTagName('input');
	var vals = inputs[0].value.split('\t');
	vals[3] = 'true';
	if (table.clickType)
		vals[4] = table.clickType;
	inputs[0].value = vals[0] + '\t' + vals[1] + '\t' + vals[2] + '\t' + vals[3] + '\t' + vals[4];
	if (!node_isSelectable(node)) {
		return;
	}
	node_addSelectedText(table,node);
	treeTable_addSelectedNode(table, node.id);
	treeTable_setLinkStyle(table, node, true);
}

treeTable_initTree = function(tableid,notifySelect,multiSelect,expandText,collapseText,expandIcon,collapseIcon,checkedIcon,uncheckedIcon,defaultOpenIconSrc,defaultClosedIconSrc,rowClasses,checkboxMode,lazyLoad,changeSelect,selectText,submitFunc)
{
	var table = document.getElementById(tableid);
	var searchButton = document.getElementById(tableid + ':htmlSearchComponent_searchAction');
	// If the search button is shown on the table turn it off because
	// full search does a filter which tree table doesn't currently support
	// Quick search is still allowed
	if (searchButton)
	{
		searchButton.style.display = 'none';
	}
	table.notifySelect = notifySelect;
	table.multiSelect = multiSelect;
	table.expandText = expandText;
	table.collapseText = collapseText;
	table.expandIcon = expandIcon;
	table.collapseIcon = collapseIcon;
	table.checkedIcon = checkedIcon;
	table.uncheckedIcon = uncheckedIcon;
	table.defaultOpenIcon = defaultOpenIconSrc;
	table.defaultClosedIcon = defaultClosedIconSrc;
	table.checkboxMode = checkboxMode;
	table.lazyLoad = lazyLoad;
	table.changeSelect = changeSelect;
	table.selectText = selectText;
	table.selectedNode = new Array();
	if (submitFunc)
	{
		table.submitFunc = submitFunc;
	}
	if (rowClasses && rowClasses.length > 1)
	{
		table.rowClasses = 	rowClasses.split(',');
	}
	
	table.clickType = '';
    /* highlight any nodes that need it*/
    treeTable_initTableRows(tableid);
} 

treeTable_getTableDiv = function(tableid)
{
	var tablediv = document.getElementById(tableid + 'bodyDiv1');
	if (!tablediv){
		tablediv = document.getElementById(tableid + 'bodyDiv2');
	}
	return tablediv;
}

treeTable_changeSelect = function(table)
{ 
    var tableDiv = treeTable_getTableDiv(table.id);
    var tempList = new Array();
    for(var i = 0; i < table.selectedNode.length; i++){ 
    	tempList[tempList.length] = table.selectedNode[i];
    }
    for(var i = 0; i < tempList.length; i++){  
    	var p = document.getElementById(tempList[i]);
    	var myparent = null;
    	if (tableDiv) {
    		myparent = treeTable_isAnyParentClosed(p);
    	} else {
    		myparent = treeTable_isAnyTreeParentClosed(table.id, p);
    	}
    	if (myparent != null)
    	{
    		treeTable_unmarkNode(table, p);
    		if (table.multiSelect == 'false')
    		{
    			treeTable_markNode(table, myparent);
    		}
   		}
    }
}

treeTable_collapseTreeNode = function(table, node)
{
	var inputs = node.getElementsByTagName('input');
    var input = inputs[0];
    var i = 0;
    var imgs = node.getElementsByTagName('img');
    var classN = imgs[i].className;
    while (classN == 'nspacer') {
    	i = i + 1;
    	classN = imgs[i].className;
    }
    var toggleImg = imgs[i];
    var iconImg = imgs[i+1];
    if (!iconImg.className)
    {
    	iconImg = imgs[i+2];
    }
    var keys = input.value.split('	');
    keys[1] = 'folder-closed';
    input.value = keys[0] + '	' +keys[1] + '	' +keys[2]+ '	' +keys[3]+ '	' +keys[4];
    toggleImg.src = "";
    if (table.expandIcon) {
    	toggleImg.src = table.expandIcon;
    }
    toggleImg.alt = "";
    if (table.expandText) {
   		toggleImg.alt = table.expandText + " | " + tree_getNodeLabel(node);
    }
    var closedIcon = iconImg.getAttribute('closedicon');
    if (closedIcon) {
        iconImg.src = closedIcon;
    }
    else {
    	if (table.defaultClosedIcon)
    		iconImg.src = table.defaultClosedIcon;
    }
    var closedLabel = node.getAttribute('closedlabel');
    if (closedLabel) {
        var lab = node.getElementsByTagName('SPAN')[0];
        lab.innerHTML = closedLabel;
    }
    var ul = node.getElementsByTagName('ul');
    if (ul.length > 0) { /* tree case */
    	ul[0].style.display = 'none';    	
    } else { /* treetable case */
    	treeTable_hideTableRows(table, node);    	
    }

	if(table.changeSelect == 'true'){
 		treeTable_changeSelect(table);
	}
}

treeTable_hideTableRows = function(table, node)
{
    /* this node was collapsed, hide all rows under this node */
    if (!table) /* tree case */
    	return;
    var rows = table.rows;
    var changed = false;
    var tableRight = document.getElementById(table.id + 'bodyDiv2');
    var tableRightRows = tableRight.rows;
    for(var i = 0; i < rows.length; i++){
    	var subnode = treeTable_getNodeFromRow(rows[i]);
    	if (subnode) {
    		var thisParent = treeTable_isParentClosed(node.id, subnode);
    		if (thisParent) {
    			rows[i].style.display = 'none'; 
    			tableRightRows[i].style.display = 'none';
    			changed = true; 
    		}
    	}
    }   
    if (changed) {
    	treeTable_adjustVScroll(table.id);
    	treeTable_adjustRowColors(table.id);
    }
}

treeTable_adjustRowColors = function(tableid)
{
	var table = treeTable_getTableDiv(tableid);
	if (!table) /* tree case */
		return;
	var t2 = document.getElementById(tableid);
	if (!t2.rowClasses) {
		return;
	}
	if (t2.rowClasses.length < 2) {
		return;
	}
    var rows = table.rows;
    var tableRight = document.getElementById(tableid + 'bodyDiv2');
    var tableRightRows = tableRight.rows;
    var changed = false;
    var rowPtr = 0;
    for(var i = 0; i < rows.length; i++){
    	var row = rows[i];
    	var rightRow = tableRightRows[i];
    	if (!row.style.display) /* row is visible */
    	{
    		if (rowPtr == 0)
    		{
    			row.className = t2.rowClasses[0];
    			rightRow.className = t2.rowClasses[0];
    			rowPtr = 1;
    		} else {
    			row.className = t2.rowClasses[1];
    			rightRow.className = t2.rowClasses[1];
    			rowPtr = 0;
    		}
    	}
    }
	
}

treeTable_findFormByElement= function(elem)
{
     var myparent = elem.parentNode;
     while( myparent != null ){
        if( myparent.tagName != null && myparent.tagName == 'form' || myparent.tagName == 'FORM' ){ 
           return myparent;
        }
        myparent = myparent.parentNode;
     }
     return null;
}

treeTable_initTableRows = function(tableid)
{
    /* collapse any nodes that need it the */
    /* first time the tree table is displayed */
    var table = treeTable_getTableDiv(tableid);
    var t2 = document.getElementById(tableid);
    if (t2.multiSelect == 'true') {
    	t2.ctrlClick = true;
    }
    var rows = table.rows;
    for(var i = 0; i < rows.length; i++){
    	var node = treeTable_getNodeFromRow(rows[i]);
        tree_initNodeEvents(table, node);  	
    	var inputs = node.getElementsByTagName('input');
	    var vals = inputs[0].value.split('\t');
        if (vals[3] == 'true') {
        	treeTable_highlightNode(table, node, true);
        }
    }    
    t2.ctrlClick = false;
}
treeTable_isParentClosed = function(topNodeid, node)
{
	var pid = node.getAttribute('pid');
	if (pid == '')
		return false;
	while (pid != null)
	{
	    if (pid == '')
	    	return false;
		if (topNodeid == pid)
			return true;
	    var pNode = document.getElementById(pid);
	    pid = pNode.getAttribute('pid');
	}
	return false;
}

treeTable_isAnyTreeParentClosed = function(treeid, node)
{
	var p = node.parentNode;
	while (p.id != treeid) {
    	if (p.style) {
        	if (p.style.display == 'none'){
            	return p.parentNode; /* return the li not the ul */
            }
        p = p.parentNode;
    	}
    }
	return null;
}

treeTable_isAnyParentClosed = function(node)
{
	var pid = node.getAttribute('pid');
	if (pid == '')
		return null;
	while (pid != null)
	{
	    if (pid == '')
	    	return null;
	    var pNode = document.getElementById(pid);
	    if (!pNode)
	    {
	    	alert('pNode == null pid = ' + pid);
	    }
	    var input = pNode.getElementsByTagName('input')[0];
        var keys = input.value.split('	');
        if (keys[1] == 'folder-closed')
        	return pNode;
	    pid = pNode.getAttribute('pid');
	}
	return null;
}

treeTable_getNodeFromRow = function(row)
{
	var nodes = row.getElementsByTagName('div');
	return nodes[0];
}

treeTable_expandTreeNode = function(table, node)
{
    var loaded = node.getAttribute('loaded');
    if (table.lazyLoad == 'true' && loaded) {
        if (loaded == 'false'){
           /* lazy load */
           var input = node.getElementsByTagName('input')[0];
           var keys = input.value.split('	');
           keys[1] = 'folder-open';
           input.value = keys[0] + '	' +keys[1] + '	' +keys[2]+ '	' +keys[3]+ '	' +keys[4];
           var ajax = node.getAttribute('ajaxexp');
           if (ajax) {
               if (ajax == 'true') {
                  return hX_6.getBehaviorById(table.id, 'ajaxsubmit', 'onget').dispatchBehavior(null, null);
               }
           }
           treeTable_submitPage(table.id);
           return;
        }
    }
    
	var inputs = node.getElementsByTagName('input');
    var input = inputs[0];
    var i = 0;
    var imgs = node.getElementsByTagName('img');
    var classN = imgs[i].className;
    while (classN == 'nspacer') {
    	i = i + 1;
    	classN = imgs[i].className;
    }
    var toggleImg = imgs[i];
    var iconImg = imgs[i+1];
    if (!iconImg.className)
    { /* skip the checkbox */
    	iconImg = imgs[i+2];
    }
    
    var keys = input.value.split('	');
    keys[1] = 'folder-open';
    input.value = keys[0] + '	' +keys[1] + '	' +keys[2]+ '	' +keys[3]+ '	' +keys[4];
        toggleImg.src = "";
    if (table.collapseIcon) {
    	toggleImg.src = table.collapseIcon;
    }
    toggleImg.alt = "";
    if (table.collapseText) {
   		toggleImg.alt = table.collapseText + " | " + tree_getNodeLabel(node);
    }
    var openIcon = iconImg.getAttribute('openicon');
    if (openIcon) {
        iconImg.src = openIcon;
    } else {
    	if (table.defaultOpenIcon)
    		iconImg.src = table.defaultOpenIcon;
    }
    
    var openLabel = node.getAttribute('openlabel');
    if (openLabel) {
        var lab = node.getElementsByTagName('SPAN')[0];
        lab.innerHTML = openLabel;
    }
    
    var ul = node.getElementsByTagName('ul');
    if (ul.length > 0) { /* tree case */
    	ul[0].style.display = 'block';    	
    } else { /* treetable case */
    	treeTable_showTableRows(table.id, node.id); 	
    }  
}

treeTable_showTableRows = function(tableid, nodeid)
{
    /* this node was expanded, show all rows under this node */
    /* but don't show rows under nodes that are still collapsed */
    var node = document.getElementById(nodeid);
    var table = treeTable_getTableDiv(tableid);
    if (!table) /* tree case */
    	return;
    var rows = table.rows;
    var tableRight = document.getElementById(tableid + 'bodyDiv2');
    var tableRightRows = tableRight.rows;
    var changed = false;
    for(var i = 0; i < rows.length; i++){
        if (rows[i].style.display == 'none') {
    		var node = treeTable_getNodeFromRow(rows[i]);
    		if (node) {
    			var thisParent = treeTable_isAnyParentClosed(node);
    			if (thisParent == null) {
    				rows[i].style.display = ''; 
    				tableRightRows[i].style.display = '';
    				changed = true;
    			}
    		}
    	}
    }    
    if (changed) {
    	treeTable_adjustVScroll(tableid);
   	    treeTable_adjustRowColors(tableid);
    }
}

treeTable_adjustVScroll = function(tableid)
{
    var outerScroll = document.getElementById(tableid + "vScrollOuter");
    outerScroll.style.display = "none";
	var hxTable = hX_6.getComponentById(tableid);
	hxTable.init(); //adjustVerticalScroll();
    outerScroll.style.display = "";
}

tree_initTree = function(treeid,notifySelect,multiSelect,expandText,collapseText,expandIcon,collapseIcon,checkedIcon,uncheckedIcon,defaultOpenIconSrc,defaultClosedIconSrc,checkboxMode,lazyLoad,changeSelect,selectText,submitFunc)
{
	var tree = document.getElementById(treeid);
	tree.notifySelect = notifySelect;
	tree.multiSelect = multiSelect;
	tree.expandText = expandText;
	tree.collapseText = collapseText;
	tree.expandIcon = expandIcon;
	tree.collapseIcon = collapseIcon;
	tree.checkedIcon = checkedIcon;
	tree.uncheckedIcon = uncheckedIcon;
	tree.defaultOpenIcon = defaultOpenIconSrc;
	tree.defaultClosedIcon = defaultClosedIconSrc;
	tree.checkboxMode = checkboxMode;
	tree.lazyLoad = lazyLoad;
	tree.changeSelect = changeSelect;
	tree.selectText = selectText;
	if (submitFunc)
	{
		tree.submitFunc = submitFunc;
	}
	tree.selectedNode = new Array();
	
	/* set any initial nodes highligted */
	if (tree.multiSelect == 'true') { /* allows multiple nodes to be selected initially */
		tree.ctrlClick = true;
	}
	tree.clickType = '';
	var listItems = tree.getElementsByTagName('li');
	for (var i = 0; i < listItems.length; i++){
		var li = listItems[i];
		tree_initNodeEvents(tree, li);
		if (tree_isHighlighted(li)){
			treeTable_highlightNode(tree, li, true);
		}
	}
	tree.ctrlClick = false;
} 

treeTable_ajaxError = function(thisObj, thisErr) {
	alert ("Ajax ERROR: " + thisErr);
	return true;
}


////////////////////////////////////////////////////////////////////////////////
// New methods added for chooser support
////////////////////////////////////////////////////////////////////////////////

tree_initNodeEvents = function(tree, node){
	node.treeId = tree.id;
	var link = node_getLabelLink(node);
	if (!node_isLeafNode(node)){
		var toggle = node_getToggle(node);
		if(toggle.addEventListener){
			toggle.addEventListener('click', tree.node_onclick_toggle,false);
			toggle.addEventListener('keydown', tree.node_keypress_toggle,false);
		}
		else if(toggle.attachEvent){
			toggle.attachEvent('onclick', tree.node_onclick_toggle);
			toggle.attachEvent('onkeydown', tree.node_keypress_toggle);
		}	
	}
	if(node_isSelectable(node)){
		if(link.addEventListener){
			link.addEventListener('click', tree.node_onclick_select,false);
			link.addEventListener('keypress', tree.node_keypress_select,false);
		}
		else if(link.attachEvent){
			link.attachEvent('onclick', tree.node_onclick_select);
			link.attachEvent('onkeypress', tree.node_keypress_select);
		}
	}
}

tree_addNode = function(node, update){
    var input = node_getInput(node);
	var vals = input.value.split('\t');
	if(update){
		vals[2] = 'true';
	}
	input.value = vals[0] + '\t' + vals[1] + '\t' + vals[2] + '\t' + vals[3] + '\t' + vals[4];
	node.style.display = 'block';
}

tree_removeNode = function(node){
    var input = node_getInput(node);
	var vals = input.value.split('\t');
	vals[2] = 'false';
	input.value = vals[0] + '\t' + vals[1] + '\t' + vals[2] + '\t' + vals[3] + '\t' + vals[4];
	node.style.display = 'none';
}

tree_isAvailable = function(node){
	var available = tree_parseValue(node, 2);
	if(available == 'true'){
		return true;
	}
	return false;
}

tree_isLeafNode = function(nodeid){  // deprecate this function
	var node = document.getElementById(nodeid);
	return node_isLeafNode(node);
}
tree_getParent = function(node){
	if(node.nodeName == 'LI'){
		var myparent = node.parentNode.parentNode;
		if(myparent.nodeName == 'LI'){
	        return myparent;
	    }
    }
    else if(node.nodeName == 'DIV'){
		var myparent = node.parentNode;
		if(myparent.nodeName == 'DIV'){
	        return myparent;
	    }
    }
	return null;
}

tree_isHighlighted = function(node){
	var nodeType = tree_parseValue(node, 3);
	if(nodeType == 'true'){
        return true;
    }
	return false;
}

tree_nodeId = function(nodeid){
	var node = document.getElementById(nodeid);
	return node_nodeId(node);
}

tree_parseValue = function(node, index){
    var input = node_getInput(node);
	var vals = input.value.split('\t');
	return vals[index];
}

tree_getParentNode = function(nodeid){
	var node = document.getElementById(nodeid);
	return node.parentNode.parentNode;
}

tree_getChildNodes = function(nodeid){
    var li = document.getElementById(nodeid);
    var children = li.childNodes;
    var ul = null;
    for(var i = 0; i < children.length; i++){
        var child = children[i];
        if(child.nodeName == 'UL'){
            ul = child;
        }
    }
    return ul ? ul.childNodes : ul;
}

tree_getNodeLabel = function(node){
	var button = node_getLabelLink(node);
	var span = button.childNodes[0];
    var mylabel = null;
    if(span.childNodes.length > 0){
    	mylabel = span.childNodes[0].nodeValue;
    }else if(span.innerText){
        mylabel = span.innerText;
    } else if(span.text){
        mylabel = span.text;
    }
    return mylabel;
}

tree_expandAllParents = function(tree, node){
	tree_displayAllParents(tree.id, node);
	var parentArray = new Array();
	var closedParent = treeTable_isAnyTreeParentClosed(tree.id, node);
	while(closedParent != null){
		parentArray[parentArray.length] = closedParent;
		closedParent = treeTable_isAnyTreeParentClosed(tree.id, closedParent);
	}
	for(var i = parentArray.length; i > 0; i--){
		var parentToExpand = parentArray[i - 1];
		treeTable_expandTreeNode(tree, parentToExpand);
	}
}

tree_displayAllParents = function(treeId, node){
	var p = node.parentNode.parentNode;
	while (p.id != treeId) {
		tree_addNode(p, false);
        p = p.parentNode.parentNode;
    }
}

tree_hasSelectedChildren = function(node){
    var fromListItems = node.getElementsByTagName('li');
    for(var i = 0; i < fromListItems.length; i++){
    	var li = fromListItems[i];
        if(tree_isAvailable(li)){
            return true;
        }
    }
    return false;
}


////////////////////////////////////////////////////////////////////////////////
// Gettors for the node elements
////////////////////////////////////////////////////////////////////////////////

node_getInput = function(node){
	var elements = node_getElements(node);
    return elements[0];
}

node_getToggle = function(node){
	var elements = node_getElements(node);
    return elements[1];
}

node_getLabelLink = function(node, checkboxMode){
	var elements = node_getElements(node);
	if(checkboxMode == 'true'){
    	return elements[4];
	}
   	return elements[3];
}

node_getElements = function(node){
	var children = node.childNodes;
    if (children.length == 1 && children[0].nodeName == 'TABLE') { // tree items with context menus
    	children = children[0].childNodes; // tbody
    	children = children[0].childNodes; // tr
    	children = children[0].childNodes; // td
    	children = children[0].childNodes; // element
    }
    return children;
}


tree_findNodeForSelectEvent = function(e){
	var node = e.target ? e.target.parentNode : e.srcElement.parentNode; 
	while(node.tagName != 'LI'){ 
		node = node.parentNode; 
	}
	return node;
}

node_addSelectedText = function(tree,node){
	var link = node_getLabelLink(node, tree.checkBoxMode);
	var selected = document.createElement('SPAN');
	selected.className = "accessible-text";
	var text = document.createTextNode(tree.selectText);
	selected.appendChild(text);
	if(link.nextSibling){
		node.insertBefore(selected, link.nextSibling);
	}
	else {
		node.appendChild(selected);
	}
}

node_removeSelectedText = function(tree,node){
	var link = node_getLabelLink(node, tree.checkBoxMode);
	var span = link.nextSibling;
	if(span && span.tagName == "SPAN"){
		node.removeChild(span);
	}
}

node_isSelectable = function(node){
	var selectable = node.getAttribute('selectable');
    if (selectable == 'true') {
		return true;
    }
    return false;	
}

node_isLeafNode = function(node){
	var nodeType = tree_parseValue(node, 1);
	if(nodeType == 'leaf'){
        return true;
    }
	return false;
}

node_nodeId = function(node){
	return tree_parseValue(node, 0);
}
