/*
 * Licensed Materials - Property of IBM
 *
 * OCO Source Materials
 *
 * (C) Copyright IBM Corp. 2007, 2011 All Rights Reserved
 *
 * The source code for this program is not published or other-
 * wise divested of its trade secrets, irrespective of what has
 * been deposited with the U.S. Copyright Office.
 */
/* filter JavaScript library */
function onStringConditionChange(srcComponent, srcEvent, targetId) {		

	var grid = document.getElementById(targetId);
	if (!grid) return false;

	if(srcComponent.value == 5 || srcComponent.value == 6) {
		//grid.style.display='none';
		grid.style.visibility="hidden";		
	} else {
		//grid.style.display='';
		grid.style.visibility="visible";		
	}
	return true;
}

function onNumberConditionChange(srcComponent, srcEvent, buttonClientId, targetIds) {		

	var targetIds = targetIds.split(',');
	if (targetIds.length != 4) return false;
		
	var grid1 = document.getElementById(targetIds[0]);
	var grid2 = document.getElementById(targetIds[1]);
	
	var input1 = document.getElementById(targetIds[2]);
	var input2 = document.getElementById(targetIds[3]);
	
	if (!grid1 || !grid2) return false;
			
	if(srcComponent.value == "0") {
		//grid1.style.display='none';
		//grid2.style.display='none';
		grid1.style.visibility="hidden";
		grid2.style.visibility="hidden";
	} else if(srcComponent.value == "7" || srcComponent.value == "8") {
		//grid1.style.display='';
		//grid2.style.display='';
		grid1.style.visibility="visible";
		grid2.style.visibility="visible";
	} else {
		//grid1.style.display='';
		//grid2.style.display='none';
		grid1.style.visibility="visible";
		grid2.style.visibility="hidden";
	}
	
	toggleNumberFilterOkButton(input1, buttonClientId, input2.id, srcComponent.id);
	
	return true;
}

function onDateConditionChange(srcComponent, srcEvent, targetIds) {		

	var targetIds = targetIds.split(',');
	if (targetIds.length != 2 && targetIds.length != 4) return false;

	var grid1 = null;
	var grid2 = null;
	var grid3 = null;
	var grid4 = null;

	if (targetIds.length == 2)
	{
		grid1 = document.getElementById(targetIds[0]);
		grid2 = document.getElementById(targetIds[1]);
	
		if (!grid1 || !grid2) return false;
				
		if(srcComponent.value == "0") {
			//grid1.style.display='none';
			//grid2.style.display='none';
			grid1.style.visibility="hidden";
			grid2.style.visibility="hidden";
		} else if(srcComponent.value == "3") {
			//grid1.style.display='';
			//grid2.style.display='';
			grid1.style.visibility="visible";
			grid2.style.visibility="visible";
		} else {
			//grid1.style.display='';
			//grid2.style.display='none';
			grid1.style.visibility="visible";
			grid2.style.visibility="hidden";
		}
	}
	
	else {
		grid1 = document.getElementById(targetIds[0]);
		grid2 = document.getElementById(targetIds[1]);
		grid3 = document.getElementById(targetIds[2]);
		grid4 = document.getElementById(targetIds[3]);
	
		if (!grid1 || !grid2 || !grid3 || !grid4) return false;
				
		if(srcComponent.value == "0") {
			//grid1.style.display='none';
			//grid2.style.display='none';
			grid1.style.visibility="hidden";
			grid2.style.visibility="hidden";
			grid3.style.visibility="hidden";
			grid4.style.visibility="hidden";
		} else if(srcComponent.value == "3") {
			//grid1.style.display='';
			//grid2.style.display='';
			grid1.style.visibility="visible";
			grid2.style.visibility="visible";
			grid3.style.visibility="visible";
			grid4.style.visibility="visible";
		} else {
			//grid1.style.display='';
			//grid2.style.display='none';
			grid1.style.visibility="visible";
			grid2.style.visibility="visible";
			grid3.style.visibility="hidden";
			grid4.style.visibility="hidden";
		}
	}

	return true;
}

function println(s) {
	var console = document.getElementById("console")
	if (console != null) {
		var div = document.createElement("div");
		div.appendChild( document.createTextNode(s));
		console.appendChild(div);
	}
}

function disableFilterOkButton(buttonClientId) {
	
  var button = document.getElementById(buttonClientId);
  if (button) {
	  button.disabled=true;
  }
	return true;	
}

function enabledFilterOkButton(buttonClientId) {
  var button = document.getElementById(buttonClientId);
  if (button) {
	  button.disabled=false;
  }
	return true;	
}


function toggleStringFilterOkButton(inputField, buttonClientId){
	var okButton = document.getElementById(buttonClientId);
	var inputValue = trimWhiteSpaces(inputField.value);
	
	if((inputValue=="") || (inputValue.length <0)){
		okButton.disabled = true;
	}else{
		okButton.disabled = false;
	}
}

function toggleNumberFilterOkButton(firstInputField, buttonClientId, secondInputFieldClientId,  selectionBoxClientId ) 
{

	var okButton = document.getElementById(buttonClientId);
	var selectionComp = document.getElementById(selectionBoxClientId);
	var secondInputField = document.getElementById(secondInputFieldClientId);
	var firstValue = firstInputField.value;
	var isNumberRegEx=/^[-+]?\d+(\.\d+)?$/;


	if(selectionComp.value == "0") 
	{
		okButton.disabled = false;
	} 
	else if(selectionComp.value == "7" || selectionComp.value == "8") 
	{
		var secondValue = secondInputField.value;
		okButton.disabled = !isNumberRegEx.test(firstValue) ||  !isNumberRegEx.test(secondValue) ;

	}
	else 
	{
		okButton.disabled = !isNumberRegEx.test(firstValue) 
	}

	return true;
}

function toggleNumberFilterOkButton2(secondInputField, buttonClientId, firstInputFieldClientId, selectionBoxClientId)
{
	var firstInputField = document.getElementById(firstInputFieldClientId);
	return toggleNumberFilterOkButton(firstInputField, buttonClientId, secondInputField.id, selectionBoxClientId);
}

function toggleDateFilterOkButton(buttonClientId, comboBoxClientId, inputClientIds ) 
{
	var okButton = document.getElementById(buttonClientId);
	var selectionComboBox = document.getElementById(comboBoxClientId);
	var dateFields = inputClientIds.split(',');
	if (dateFields.length != 2) return false;

	var date1Field = document.getElementById(dateFields[0]);
	var date2Field = document.getElementById(dateFields[1]);

	var date1Value = date1Field.value;

	if(selectionComboBox.value == "0") 
	{
		okButton.disabled = false;
	} 
	else if(selectionComboBox.value == "3") 
	{
		var date2Value = date2Field.value;
		okButton.disabled = date1Value == "" || date2Value == "";
	}
	else 
	{
		okButton.disabled = date1Value == "" ;
	}

	return true;
}

function trimWhiteSpaces(strValue){
	var objRegExp = /^(\s*)$/;

    //check for all spaces
    if(objRegExp.test(strValue)) {
       strValue = strValue.replace(objRegExp, '');
       if( strValue.length == 0)
          return strValue;
    }

   //check for leading & trailing spaces
   objRegExp = /^(\s*)([\W\w]*)(\b\s*$)/;
   if(objRegExp.test(strValue)) {
       //remove leading and trailing whitespace characters
       strValue = strValue.replace(objRegExp, '$2');
    }
  return strValue;
}

